diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 6fad4d3fe52..cb5f3ca1fc5 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -101,11 +101,10 @@ extern const struct win32_funcs *win32_funcs DECLSPEC_HIDDEN;
 static CFMutableArrayRef device_main_elements = NULL;
 
 typedef struct JoystickImpl JoystickImpl;
-static const IDirectInputDevice8WVtbl JoystickWvt;
 
 struct JoystickImpl
 {
-    struct JoystickGenericImpl generic;
+    struct JoystickGenericImpl *generic;
 
     /* osx private */
     int                    id;
@@ -845,7 +844,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                         if (valueRef == NULL)
                             return;
                         val = IOHIDValueGetIntegerValue(valueRef);
-                        win32_funcs->joystick_queue_event(&device->generic, DIDFT_PSHBUTTON, button_idx, val ? 0x80 : 0x0);
+                        win32_funcs->joystick_queue_event(device->generic, DIDFT_PSHBUTTON, button_idx, val ? 0x80 : 0x0);
                         button_idx ++;
                     }
                     break;
@@ -865,7 +864,7 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                             val = IOHIDValueGetIntegerValue(valueRef);
                             if (val >= 8) val = -1;
                             else val = val * 4500;
-                            win32_funcs->joystick_queue_event(&device->generic, DIDFT_POV, pov_idx, val);
+                            win32_funcs->joystick_queue_event(device->generic, DIDFT_POV, pov_idx, val);
                             pov_idx ++;
                             break;
                         }
@@ -887,31 +886,31 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr)
                             {
                             case kHIDUsage_GD_X:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_X\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 0, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 0, val);
                                 break;
                             case kHIDUsage_GD_Y:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Y\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 1, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 1, val);
                                 break;
                             case kHIDUsage_GD_Z:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Z\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 2, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 2, val);
                                 break;
                             case kHIDUsage_GD_Rx:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Rx\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 3, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 3, val);
                                 break;
                             case kHIDUsage_GD_Ry:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Ry\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 4, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 4, val);
                                 break;
                             case kHIDUsage_GD_Rz:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Rz\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 5, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 5, val);
                                 break;
                             case kHIDUsage_GD_Slider:
                                 TRACE("kIOHIDElementTypeInput_Misc / kHIDUsage_GD_Slider\n");
-                                win32_funcs->joystick_queue_event(&device->generic, DIDFT_ABSAXIS, 6 + slider_idx, val);
+                                win32_funcs->joystick_queue_event(device->generic, DIDFT_ABSAXIS, 6 + slider_idx, val);
                                 slider_idx ++;
                                 break;
                             }
@@ -937,11 +936,13 @@ static HRESULT CDECL unix_joystick_ff_send_cmd(struct unix_joystick *ptr, DWORD
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, DWORD type, const DIEFFECT *params,
         const struct unix_effect_vtbl **vtbl, struct unix_effect **out);
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff);
+static void CDECL unix_joystick_destroy(struct unix_joystick *ptr);
 
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
     unix_joystick_init,
+    unix_joystick_destroy,
     NULL,
     NULL,
     NULL,
@@ -1070,10 +1071,8 @@ static BOOL osx_axis_has_ff(FFCAPABILITIES *ffcaps, UInt8 axis)
     return FALSE;
 }
 
-static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW didi, IOHIDDeviceRef device, DWORD version, int index, const char *name)
+static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA didi, IOHIDDeviceRef device, DWORD version, int index, const char *name)
 {
-    char buffer[MAX_PATH];
-
     didi->guidInstance = DInput_Wine_OsX_Joystick_GUID;
     didi->guidInstance.Data3 = index;
     didi->guidProduct = DInput_PIDVID_Product_GUID;
@@ -1081,9 +1080,8 @@ static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW didi, IOHIDDevic
     if (version >= 0x0800) didi->dwDevType = DI8DEVTYPE_JOYSTICK | (DI8DEVTYPEJOYSTICK_STANDARD << 8);
     else didi->dwDevType = DIDEVTYPE_JOYSTICK | (DIDEVTYPEJOYSTICK_TRADITIONAL << 8);
 
-    snprintf(buffer, sizeof(buffer), "Joystick %d", index);
-    MultiByteToWideChar(CP_ACP, 0, buffer, -1, didi->tszInstanceName, MAX_PATH);
-    MultiByteToWideChar(CP_ACP, 0, name, -1, didi->tszProductName, MAX_PATH);
+    snprintf(didi->tszInstanceName, sizeof(didi->tszInstanceName), "Joystick %d", index);
+    lstrcpynA(didi->tszProductName,  name, MAX_PATH);
 
     didi->guidFFDriver = GUID_NULL;
     didi->wUsagePage = 0;
@@ -1110,19 +1108,13 @@ static unsigned short get_joystick_index(REFGUID guid)
     return 0xffff;
 }
 
-static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
+static HRESULT joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
 {
-    DIDEVICEINSTANCEW didi = {sizeof(didi)};
     IOHIDDeviceRef device;
     JoystickImpl* newDevice;
     char name[MAX_PATH];
     unsigned short index;
     int joystick_devices_count;
-    WORD vendor_id, product_id;
-
-    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
-
-    *out = NULL;
 
     if ((joystick_devices_count = find_joystick_devices()) == 0) return DIERR_DEVICENOTREG;
 
@@ -1131,25 +1123,22 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
 
     device = get_device_ref(index);
     get_osx_device_name(index, name, MAX_PATH);
-    vendor_id = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
-    product_id = get_device_property_long(device, CFSTR(kIOHIDProductIDKey));
 
-    fill_joystick_dideviceinstanceW(&didi, device, dinput->dwVersion, index, name);
-
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, guid, vendor_id, product_id, index,
-                       &didi, dinput, (void **)&newDevice)))
-        return hr;
-    newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
-    newDevice->generic.unix_funcs = &unix_joystick_vtbl;
-    newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
+    fill_joystick_dideviceinstanceA(info, device, version, index, name);
 
+    if (!(newDevice = HeapAlloc(GetProcessHeap(), HEAP_ZERO_MEMORY, sizeof(*newDevice)))) return DIERR_OUTOFMEMORY;
     newDevice->id = index;
 
-    *out = &newDevice->generic;
+    *vid = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
+    *pid = get_device_property_long(device, CFSTR(kIOHIDProductIDKey));
+    *iid = index;
+    *vtbl = &unix_joystick_vtbl;
+    *ptr = unix_joystick_from_impl(newDevice);
+
     return DI_OK;
 }
 
-static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff)
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
     IOHIDDeviceRef device;
@@ -1160,6 +1149,7 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     int axis_map[8]; /* max axes */
 
     device = get_device_ref(This->id);
+    This->generic = generic;
 
     /* get the device name */
     get_osx_device_name(This->id, name, MAX_PATH);
@@ -1206,6 +1196,12 @@ static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr, ObjProps *pro
     return DI_OK;
 }
 
+static void CDECL unix_joystick_destroy(struct unix_joystick *ptr)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    HeapFree(GetProcessHeap(), 0, This);
+}
+
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
@@ -1314,42 +1310,6 @@ const struct dinput_device joystick_osx_device = {
   joydev_create_unix_joystick
 };
 
-static const IDirectInputDevice8WVtbl JoystickWvt =
-{
-    IDirectInputDevice2WImpl_QueryInterface,
-    IDirectInputDevice2WImpl_AddRef,
-    IDirectInputDevice2WImpl_Release,
-    JoystickWGenericImpl_GetCapabilities,
-    IDirectInputDevice2WImpl_EnumObjects,
-    JoystickWGenericImpl_GetProperty,
-    JoystickWGenericImpl_SetProperty,
-    IDirectInputDevice2WImpl_Acquire,
-    IDirectInputDevice2WImpl_Unacquire,
-    JoystickWGenericImpl_GetDeviceState,
-    IDirectInputDevice2WImpl_GetDeviceData,
-    IDirectInputDevice2WImpl_SetDataFormat,
-    IDirectInputDevice2WImpl_SetEventNotification,
-    IDirectInputDevice2WImpl_SetCooperativeLevel,
-    JoystickWGenericImpl_GetObjectInfo,
-    IDirectInputDevice2WImpl_GetDeviceInfo,
-    IDirectInputDevice2WImpl_RunControlPanel,
-    IDirectInputDevice2WImpl_Initialize,
-    JoystickWGenericImpl_CreateEffect,
-    IDirectInputDevice2WImpl_EnumEffects,
-    IDirectInputDevice2WImpl_GetEffectInfo,
-    IDirectInputDevice2WImpl_GetForceFeedbackState,
-    JoystickWGenericImpl_SendForceFeedbackCommand,
-    JoystickWGenericImpl_EnumCreatedEffectObjects,
-    IDirectInputDevice2WImpl_Escape,
-    JoystickWGenericImpl_Poll,
-    IDirectInputDevice2WImpl_SendDeviceData,
-    IDirectInputDevice7WImpl_EnumEffectsInFile,
-    IDirectInputDevice7WImpl_WriteEffectToFile,
-    JoystickWGenericImpl_BuildActionMap,
-    JoystickWGenericImpl_SetActionMap,
-    IDirectInputDevice8WImpl_GetImageInfo
-};
-
 static void CDECL unix_effect_destroy(struct unix_effect *ptr)
 {
     EffectImpl *This = impl_from_unix_effect(ptr);
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index 4e5b3eaa245..34f2260173b 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -31,7 +31,7 @@
 
 /* Number of objects in the default data format */
 #define MAX_PROPS 164
-struct JoystickGenericImpl;
+typedef struct JoystickGenericImpl JoystickGenericImpl;
 
 struct unix_effect;
 
@@ -52,7 +52,8 @@ struct unix_joystick;
 
 struct unix_joystick_vtbl
 {
-    HRESULT (CDECL *init)(struct unix_joystick *ptr, ObjProps *props, int *prop_count, BOOL *has_ff);
+    HRESULT (CDECL *init)(struct unix_joystick *ptr, JoystickGenericImpl *generic, ObjProps *props, int *prop_count, BOOL *has_ff);
+    void (CDECL *destroy)(struct unix_joystick *ptr);
     void (CDECL *reset)(struct unix_joystick *ptr);
 
     void (CDECL *get_mapping)(struct unix_joystick *ptr, int *axis_count, const int **axes_map);
@@ -72,23 +73,6 @@ struct unix_joystick_vtbl
     void (CDECL *poll)(struct unix_joystick *ptr);
 };
 
-typedef struct JoystickGenericImpl
-{
-    struct IDirectInputDeviceImpl base;
-    const struct unix_joystick_vtbl *unix_funcs;
-    struct unix_joystick *unix_ptr;
-
-    ObjProps    props[MAX_PROPS];
-    DIDEVCAPS   devcaps;
-    DIJOYSTATE2 js;     /* wine data */
-    int        *axis_map;               /* User axes remapping */
-    LONG        deadzone;               /* Default dead-zone */
-
-    DWORD ff_autocenter;
-    DWORD ff_gain;
-    struct list ff_effects;
-} JoystickGenericImpl;
-
 extern HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out) DECLSPEC_HIDDEN;
 
 DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
@@ -98,42 +82,6 @@ extern BOOL device_disabled_registry(const WCHAR* name) DECLSPEC_HIDDEN;
 extern int CDECL dinput_unix_joystick_get_axis(JoystickGenericImpl *This, int index) DECLSPEC_HIDDEN;
 extern void CDECL dinput_unix_joystick_queue_event(JoystickGenericImpl *This, WORD type, int index, DWORD data) DECLSPEC_HIDDEN;
 
-HRESULT WINAPI JoystickWGenericImpl_GetObjectInfo(LPDIRECTINPUTDEVICE8W iface,
-        LPDIDEVICEOBJECTINSTANCEW pdidoi, DWORD dwObj, DWORD dwHow) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_GetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPDIPROPHEADER pdiph) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_GetCapabilities(LPDIRECTINPUTDEVICE8W iface, LPDIDEVCAPS lpDIDevCaps) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_SetProperty(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIPROPHEADER ph) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_Acquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_Unacquire(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_GetEffectInfo(LPDIRECTINPUTDEVICE8W iface, LPDIEFFECTINFOW pdei, REFGUID rguid) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_EnumEffects(LPDIRECTINPUTDEVICE8W iface, LPDIENUMEFFECTSCALLBACKW lpCallback,
-        LPVOID pvRef, DWORD dwEffType) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_CreateEffect(LPDIRECTINPUTDEVICE8W iface, REFGUID rguid, LPCDIEFFECT lpeff,
-        LPDIRECTINPUTEFFECT *ppdef, LPUNKNOWN pUnkOuter) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_EnumCreatedEffectObjects(LPDIRECTINPUTDEVICE8W iface,
-        LPDIENUMCREATEDEFFECTOBJECTSCALLBACK lpCallback, LPVOID pvRef, DWORD dwFlags) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_GetForceFeedbackState(LPDIRECTINPUTDEVICE8W iface, LPDWORD pdwOut) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_SendForceFeedbackCommand(LPDIRECTINPUTDEVICE8W iface, DWORD dwFlags) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_Poll(LPDIRECTINPUTDEVICE8W iface) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_BuildActionMap(LPDIRECTINPUTDEVICE8W iface, LPDIACTIONFORMATW lpdiaf, LPCWSTR lpszUserName, DWORD dwFlags) DECLSPEC_HIDDEN;
-
-HRESULT WINAPI JoystickWGenericImpl_SetActionMap(LPDIRECTINPUTDEVICE8W iface, LPDIACTIONFORMATW lpdiaf, LPCWSTR lpszUserName, DWORD dwFlags) DECLSPEC_HIDDEN;
-
 DWORD typeFromGUID(REFGUID guid) DECLSPEC_HIDDEN;
 
 #endif /* __WINE_DLLS_DINPUT_JOYSTICK_PRIVATE_H */
-- 
2.28.0

>From f27e6ba6394ef16ea69c8a5fbef854b1cc37ff39 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Mon, 5 Oct 2020 12:44:48 +0200
Subject: [PATCH 37/39] dinput: Introduce unix_funcs to enumerate unix devices.

---
 dlls/dinput/dinput_main.c         | 30 +++++++++++++++++++++++++++++-
 dlls/dinput/dinput_private.h      | 13 +++++++++----
 dlls/dinput/joystick_linux.c      |  4 ++--
 dlls/dinput/joystick_linuxinput.c |  4 ++--
 dlls/dinput/joystick_osx.c        |  4 ++--
 dlls/dinput/keyboard.c            |  6 +++---
 dlls/dinput/mouse.c               |  4 ++--
 7 files changed, 49 insertions(+), 16 deletions(-)

diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index 66a65b7b55e..a7341171bcc 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -75,10 +75,15 @@ static inline IDirectInputDeviceImpl *impl_from_IDirectInputDevice8W(IDirectInpu
     return CONTAINING_RECORD(iface, IDirectInputDeviceImpl, IDirectInputDevice8W_iface);
 }
 
-static const struct dinput_device *dinput_devices[] =
+static const struct dinput_device *dinput_devices[32] =
 {
     &mouse_device,
     &keyboard_device,
+    NULL,
+};
+
+static const struct dinput_device *unix_devices[] =
+{
     &joystick_linuxinput_device,
     &joystick_linux_device,
     &joystick_osx_device
@@ -92,6 +97,20 @@ const struct win32_funcs win32_entry =
 
 const struct win32_funcs *win32_funcs = &win32_entry;
 
+static HRESULT CDECL unix_get_dinput_device(unsigned int index, const struct dinput_device **out)
+{
+    if (index >= ARRAY_SIZE(unix_devices)) return E_FAIL;
+    *out = unix_devices[index];
+    return DI_OK;
+}
+
+const struct unix_funcs unix_entry =
+{
+    unix_get_dinput_device
+};
+
+static const struct unix_funcs *unix_funcs = &unix_entry;
+
 HINSTANCE DINPUT_instance;
 
 static const WCHAR di_em_win_w[] = {'D','I','E','m','W','i','n',0};
@@ -391,6 +410,7 @@ static HRESULT WINAPI IDirectInputWImpl_EnumDevices(
         return DIERR_NOTINITIALIZED;
 
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++) {
+        if (!dinput_devices[i]) break;
         for (j = 0, r = S_OK; SUCCEEDED(r); j++) {
             devInstance.dwSize = sizeof(devInstance);
             TRACE("  - checking device %u ('%s')\n", i, dinput_devices[i]->name);
@@ -676,6 +696,7 @@ static HRESULT WINAPI IDirectInput7WImpl_CreateDeviceEx(LPDIRECTINPUT7W iface, R
     /* Loop on all the devices to see if anyone matches the given GUID */
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
     {
+        if (!dinput_devices[i]) break;
         if (SUCCEEDED(hr = dinput_create_device(dinput_devices[i], This, rguid, riid, pvOut))) return hr;
     }
 
@@ -828,6 +849,7 @@ static HRESULT WINAPI IDirectInput8WImpl_EnumDevicesBySemantics(
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
     {
         HRESULT enumSuccess;
+        if (!dinput_devices[i]) break;
         for (j = 0, enumSuccess = S_OK; SUCCEEDED(enumSuccess); j++)
         {
             TRACE(" - checking device %u ('%s')\n", i, dinput_devices[i]->name);
@@ -1000,6 +1022,7 @@ static HRESULT WINAPI JoyConfig8Impl_GetConfig(IDirectInputJoyConfig8 *iface, UI
     /* Enumerate all joysticks in order */
     for (i = 0; i < ARRAY_SIZE(dinput_devices); i++)
     {
+        if (!dinput_devices[i]) break;
         for (j = 0, r = S_OK; SUCCEEDED(r); j++)
         {
             DIDEVICEINSTANCEW dev;
@@ -1501,12 +1524,17 @@ void check_dinput_events(void)
 
 BOOL WINAPI DllMain( HINSTANCE inst, DWORD reason, LPVOID reserved)
 {
+    unsigned int i = 0;
+    const struct dinput_device **device = dinput_devices, **device_last = dinput_devices + ARRAY_SIZE(dinput_devices) - 1;
     switch(reason)
     {
       case DLL_PROCESS_ATTACH:
         DisableThreadLibraryCalls(inst);
         DINPUT_instance = inst;
         register_di_em_win_class();
+        while (device < device_last && *device) device++;
+        while (device < device_last && SUCCEEDED(unix_funcs->get_dinput_device(i++, device))) device++;
+        *device = NULL;
         break;
       case DLL_PROCESS_DETACH:
         if (reserved) break;
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 99cc3ce4a1c..22cad3d02cc 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -61,10 +61,15 @@ struct unix_joystick;
 /* Function called by all devices that Wine supports */
 struct dinput_device {
     const char *name;
-    HRESULT (*enum_deviceA)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id);
-    HRESULT (*enum_deviceW)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id);
-    HRESULT (*create_device)(IDirectInputImpl *dinput, REFGUID rguid, IDirectInputDeviceImpl **out);
-    HRESULT (*create_unix_joystick)(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info);
+    HRESULT (CDECL *enum_deviceA)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id);
+    HRESULT (CDECL *enum_deviceW)(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id);
+    HRESULT (CDECL *create_device)(IDirectInputImpl *dinput, REFGUID rguid, IDirectInputDeviceImpl **out);
+    HRESULT (CDECL *create_unix_joystick)(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info);
+};
+
+struct unix_funcs
+{
+    HRESULT (CDECL *get_dinput_device)(unsigned int index, const struct dinput_device **out);
 };
 
 typedef struct JoystickGenericImpl JoystickGenericImpl;
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index a9c57e136de..c5194720e4c 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -395,7 +395,7 @@ static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD ver
     lpddi->guidFFDriver = GUID_NULL;
 }
 
-static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
+static HRESULT CDECL joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
 {
     int fd = -1;
 
@@ -444,7 +444,7 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYSTICKS;
 }
 
-static HRESULT joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
+static HRESULT CDECL joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
 {
     struct JoyDev *joydev;
     JoystickImpl *newDevice;
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 7c9fdba9418..1e72dd59339 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -445,7 +445,7 @@ static void fill_joystick_dideviceinstanceA(LPDIDEVICEINSTANCEA lpddi, DWORD ver
     lstrcpynA(lpddi->tszProductName,  joydevs[id].name, MAX_PATH);
 }
 
-static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
+static HRESULT CDECL joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
 {
   find_joydevs();
 
@@ -490,7 +490,7 @@ static unsigned short get_joystick_index(REFGUID guid)
     return MAX_JOYDEV;
 }
 
-static HRESULT joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
+static HRESULT CDECL joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
 {
     struct JoyDev *joydev;
     JoystickImpl *newDevice;
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index cb5f3ca1fc5..ff11e8514a0 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1001,7 +1001,7 @@ static DWORD make_vid_pid(IOHIDDeviceRef device)
     return MAKELONG(vendID, prodID);
 }
 
-static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
+static HRESULT CDECL joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEA lpddi, DWORD version, int id)
 {
     IOHIDDeviceRef device;
     BOOL is_joystick;
@@ -1108,7 +1108,7 @@ static unsigned short get_joystick_index(REFGUID guid)
     return 0xffff;
 }
 
-static HRESULT joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
+static HRESULT CDECL joydev_create_unix_joystick(REFGUID guid, DWORD version, const struct unix_joystick_vtbl **vtbl, struct unix_joystick **ptr, WORD *vid, WORD *pid, WORD *iid, DIDEVICEINSTANCEA *info)
 {
     IOHIDDeviceRef device;
     JoystickImpl* newDevice;
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index b257f2b51c1..c3dc8b9319f 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -172,8 +172,8 @@ static void fill_keyboard_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD ver
 
     memcpy(lpddi, &ddi, (dwSize < sizeof(ddi) ? dwSize : sizeof(ddi)));
 }
- 
-static HRESULT keyboarddev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
+
+static HRESULT CDECL keyboarddev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
 {
   if (id != 0)
     return E_FAIL;
@@ -238,7 +238,7 @@ failed:
     return NULL;
 }
 
-static HRESULT keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
+static HRESULT CDECL keyboarddev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
     TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
     *out = NULL;
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index c436bf5032a..afaa7d14c8e 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -117,7 +117,7 @@ static void fill_mouse_dideviceinstanceW(LPDIDEVICEINSTANCEW lpddi, DWORD versio
     memcpy(lpddi, &ddi, (dwSize < sizeof(ddi) ? dwSize : sizeof(ddi)));
 }
 
-static HRESULT mousedev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
+static HRESULT CDECL mousedev_enum_deviceW(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINSTANCEW lpddi, DWORD version, int id)
 {
     if (id != 0)
         return E_FAIL;
@@ -196,7 +196,7 @@ failed:
     return NULL;
 }
 
-static HRESULT mousedev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
+static HRESULT CDECL mousedev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
 {
     TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
     *out = NULL;
-- 
2.28.0

>From 999458082bb1bdbfc47e1448db7b681c4ca7d2ce Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 14:17:10 +0200
Subject: [PATCH 38/39] dinput: Split unix joysticks to a separate unix lib.

---
 dlls/dinput/Makefile.in           |   3 +-
 dlls/dinput/device_private.h      |   2 -
 dlls/dinput/dinput_main.c         |  41 ++----
 dlls/dinput/dinput_private.h      |   3 +-
 dlls/dinput/effect_linuxinput.c   |  14 ++-
 dlls/dinput/joystick.c            |  28 -----
 dlls/dinput/joystick_linux.c      |  13 +-
 dlls/dinput/joystick_linuxinput.c |  17 ++-
 dlls/dinput/joystick_osx.c        |  15 ++-
 dlls/dinput/joystick_private.h    |   4 +-
 dlls/dinput/unixlib.c             | 202 ++++++++++++++++++++++++++++++
 dlls/dinput/unixlib_private.h     |  38 ++++++
 dlls/dinput8/Makefile.in          |   3 +-
 13 files changed, 300 insertions(+), 83 deletions(-)
 create mode 100644 dlls/dinput/unixlib.c
 create mode 100644 dlls/dinput/unixlib_private.h

diff --git a/dlls/dinput/device_private.h b/dlls/dinput/device_private.h
index c244550e105..5611d57e99f 100644
--- a/dlls/dinput/device_private.h
+++ b/dlls/dinput/device_private.h
@@ -119,8 +119,6 @@ typedef struct
     DWORD dwFlags;
 } ObjProps;
 
-extern DWORD joystick_map_pov(const POINTL *p) DECLSPEC_HIDDEN;
-
 extern const GUID DInput_PIDVID_Product_GUID DECLSPEC_HIDDEN;
 
 /* Various debug tools */
diff --git a/dlls/dinput/dinput_main.c b/dlls/dinput/dinput_main.c
index a7341171bcc..05763d0b3f4 100644
--- a/dlls/dinput/dinput_main.c
+++ b/dlls/dinput/dinput_main.c
@@ -38,21 +38,26 @@
 #define COBJMACROS
 #define NONAMELESSUNION
 
-#include "wine/debug.h"
-#include "wine/unicode.h"
-#include "wine/asm.h"
+#include "ntstatus.h"
+#define WIN32_NO_STATUS
 #include "windef.h"
 #include "winbase.h"
 #include "winuser.h"
 #include "winerror.h"
+#include "winternl.h"
 #include "objbase.h"
 #include "rpcproxy.h"
 #include "initguid.h"
 #include "devguid.h"
+#include "dinputd.h"
+
+#include "wine/debug.h"
+#include "wine/unicode.h"
+#include "wine/asm.h"
+
 #include "dinput_private.h"
 #include "device_private.h"
 #include "joystick_private.h"
-#include "dinputd.h"
 
 WINE_DEFAULT_DEBUG_CHANNEL(dinput);
 
@@ -82,35 +87,14 @@ static const struct dinput_device *dinput_devices[32] =
     NULL,
 };
 
-static const struct dinput_device *unix_devices[] =
-{
-    &joystick_linuxinput_device,
-    &joystick_linux_device,
-    &joystick_osx_device
-};
+static const struct unix_funcs *unix_funcs;
 
-const struct win32_funcs win32_entry =
+static const struct win32_funcs win32_funcs =
 {
     dinput_unix_joystick_get_axis,
-    dinput_unix_joystick_queue_event
-};
-
-const struct win32_funcs *win32_funcs = &win32_entry;
-
-static HRESULT CDECL unix_get_dinput_device(unsigned int index, const struct dinput_device **out)
-{
-    if (index >= ARRAY_SIZE(unix_devices)) return E_FAIL;
-    *out = unix_devices[index];
-    return DI_OK;
-}
-
-const struct unix_funcs unix_entry =
-{
-    unix_get_dinput_device
+    dinput_unix_joystick_queue_event,
 };
 
-static const struct unix_funcs *unix_funcs = &unix_entry;
-
 HINSTANCE DINPUT_instance;
 
 static const WCHAR di_em_win_w[] = {'D','I','E','m','W','i','n',0};
@@ -1526,6 +1510,7 @@ BOOL WINAPI DllMain( HINSTANCE inst, DWORD reason, LPVOID reserved)
 {
     unsigned int i = 0;
     const struct dinput_device **device = dinput_devices, **device_last = dinput_devices + ARRAY_SIZE(dinput_devices) - 1;
+    if (__wine_init_unix_lib(inst, reason, &win32_funcs, &unix_funcs)) return FALSE;
     switch(reason)
     {
       case DLL_PROCESS_ATTACH:
diff --git a/dlls/dinput/dinput_private.h b/dlls/dinput/dinput_private.h
index 22cad3d02cc..030d7f3ead1 100644
--- a/dlls/dinput/dinput_private.h
+++ b/dlls/dinput/dinput_private.h
@@ -25,7 +25,9 @@
 #include "winbase.h"
 #include "dinput.h"
 #include "dinputd.h"
+
 #include "wine/list.h"
+#include "wine/debug.h"
 
 extern HINSTANCE DINPUT_instance;
 
@@ -109,7 +111,6 @@ extern void check_dinput_events(void) DECLSPEC_HIDDEN;
 extern HRESULT _configure_devices(IDirectInput8W *iface, LPDICONFIGUREDEVICESCALLBACK lpdiCallback, LPDICONFIGUREDEVICESPARAMSW lpdiCDParams, DWORD dwFlags, LPVOID pvRefData) DECLSPEC_HIDDEN;
 
 extern WCHAR* get_mapping_path(const WCHAR *device, const WCHAR *username) DECLSPEC_HIDDEN;
-extern DWORD get_device_type(DWORD version, BOOL is_joystick) DECLSPEC_HIDDEN;
 
 #define IS_DIPROP(x)    (((ULONG_PTR)(x) >> 16) == 0)
 
